/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: GeneratorV4.java,v 1.1 2000/07/19 00:33:55 pmahar Exp $
 */

package org.enhydra.kelp.common.bridge;

// XMLC imports
import org.enhydra.xml.xmlc.XMLCException;
import org.enhydra.xml.xmlc.compiler.ClassGenerator;
import org.enhydra.xml.xmlc.dom.XMLCDocument;
import org.enhydra.xml.xmlc.metadata.MetaData;

// Standard imports
import java.io.PrintWriter;
import java.io.IOException;

public class GeneratorV4 implements Generator {
  private ClassGenerator codeGen = null;

  public GeneratorV4(MetaDataHandler handler,
                     XMLCDocument xmlcDoc,
                     PrintWriter verboseOutput)
                     throws XMLCException {

        MetaData metaData = null;
        metaData = (MetaData) handler.getMetaData();
        codeGen = new ClassGenerator(metaData, xmlcDoc, verboseOutput);
  }

  public void generateJavaSource(PrintWriter writer)
      throws XMLCException {
    try {
      codeGen.generateJavaSource(writer);
    } catch (IOException e) {
      XMLCException xe = new XMLCException(e);
    }
  }

}