/*
 * Enhydra Java Application Server
 * The Initial Developer of the Original Code is Lutris Technologies Inc.
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc.
 * All Rights Reserved.
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License.
 *
 * $Id: OtterNodeFactory.java,v 1.5 2000/07/21 19:53:03 pmahar Exp $
 */
package org.enhydra.kelp.common.node;

import org.enhydra.kelp.common.wizard.CodeImporter;
import java.io.File;

/**
 * Interface declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
public abstract class OtterNodeFactory {

    /**
     * Method declaration
     *
     *
     * @param project
     * @param node
     * @param name
     *
     * @return
     *
     * @see
     */
    abstract public OtterFolderNode createFolderNode(OtterProject project,
                                            OtterNode node, String name);

    /**
     * Method declaration
     *
     *
     * @param project
     * @param node
     * @param file
     *
     * @return
     *
     * @see
     */
    abstract public OtterHTMLFileNode createHTMLFileNode(OtterProject project,
                                                OtterNode node, String file);


    abstract public OtterWMLFileNode createWMLFileNode(OtterProject project,
                                              OtterNode node, String file);

    /**
     * Method declaration
     *
     *
     * @param project
     * @param node
     * @param file
     *
     * @return
     *
     * @see
     */
    abstract public OtterImageFileNode createImageFileNode(OtterProject project,
            OtterNode node, String file);

    /**
     * Method declaration
     *
     *
     * @param project
     * @param node
     * @param file
     *
     * @return
     *
     * @see
     */
    abstract public OtterJavaFileNode createJavaFileNode(OtterProject project,
                                                OtterNode node, String file);

    /**
     * Method declaration
     *
     *
     * @param project
     * @param node
     * @param file
     *
     * @return
     *
     * @see
     */
    abstract public OtterTextFileNode createTextFileNode(OtterProject project,
                                                OtterNode node, String file);

    /**
     * Method declaration
     *
     *
     * @param project
     * @param node
     * @param file
     *
     * @return
     *
     * @see
     */
    abstract public OtterTemplateNode createTemplateNode(OtterProject project,
                                                OtterNode node, String file);

    /**
     * Method declaration
     *
     *
     * @param project
     * @param node
     * @param file
     *
     * @return
     *
     * @see
     */
    abstract public OtterJavaFileNode[] replaceGeneratedSource(OtterProject project,
            OtterNode node, String[] files);

    //
    //
    public void importFile(OtterProject project,
                           File newFile) {
        File        source   = null;
        File[]      files     = new File[1];
        CodeImporter importer = null;

        files[0] = newFile;
        source = new File(project.getSourcePathArray()[0]);
        if (! source.exists()) {
          source = (new File(project.getFilePath())).getParentFile();
        }
        importer = new CodeImporter();
        try {
          importer.setSource(source);
        } catch (Exception e) {
          e.printStackTrace();
        }
        importer.addFiles(project, files);
    }

}
