package org.enhydra.kelp.common.wizard.codegen;

/**
 * The WebAppException is thrown for exceptions in the
 * WebAppUtil class.
 */
public class CodeGenException extends Exception {
    private Throwable parent = null;
    private boolean   decoy = false;

    /**
     * Create a GeneratorException with a specified error message.
     *
     * @param message
     * Message providing information on the nature of the exception.
     */
    public CodeGenException(String message) {
        super(message);
    }

    /**
     * Constructor declaration
     *
     *
     * @param hidden
     *
     * @see
     */
    public CodeGenException(Throwable hidden) {
        super("");
        parent = hidden;
        decoy = true;
    }

    /**
     * Constructor declaration
     *
     *
     * @param chain
     * @param message
     *
     * @see
     */
    public CodeGenException(Throwable chain, String message) {
        super(message);
        parent = chain;
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    public String getMessage() {
        StringBuffer buf = new StringBuffer();

        if ((!decoy) || (parent == null)) {
            buf.append(super.getMessage());
        }
        if (parent != null) {
            buf.append("\n");
            buf.append("     " + parent.getMessage());
        }
        return buf.toString();
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    public void printStackTrace() {
        if ((!decoy) || (parent == null)) {
            super.printStackTrace();
        }
        if (parent != null) {
            parent.printStackTrace();
        }
    }

}
