/*
 * Enhydra Java Application Server
 * The Initial Developer of the Original Code is Lutris Technologies Inc.
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc.
 * All Rights Reserved.
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License.
 *
 * $Id: XMLCOptionPanel.java,v 1.4 2000/07/24 07:23:00 pmahar Exp $
 */
package org.enhydra.kelp.common.wizard.xmlc;
// Kelp imports
import org.enhydra.kelp.common.swing.ExtensionFilter;
import org.enhydra.kelp.common.node.OtterNode;

// Standard imports
import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.event.*;
import java.io.File;
import java.awt.*;
import java.beans.*;

/**
 * Class declaration
 *
 *
 * @author Paul Mahar
 * @version $Revision: 1.4 $
 */
public class XMLCOptionPanel extends JPanel {
    private OtterNode           node;
    private JTextField          textFile;
    private JButton             buttonBrowse;
    private LocalButtonListener buttonListener;
    private TitledBorder        border;
    private GridBagLayout       layoutMain = new GridBagLayout();
    private JTextField          textCommandLine;
    private JLabel              labelCommandLine;
    private JLabel              labelFile;
    private JButton             buttonClear;
    private JButton             buttonTool;
    /**
     * Constructor declaration
     *
     *
     * @see
     */
    public XMLCOptionPanel() {
        try {
            jbInit();
            pmInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    private void pmInit() {
        textCommandLine.setText("");
        buttonListener = new LocalButtonListener();
        buttonBrowse.addActionListener(buttonListener);
        buttonClear.addActionListener(buttonListener);
        setEnabled(true);
    }

    /**
     * Method declaration
     *
     *
     * @exception Exception
     *
     * @see
     */
    private void jbInit() throws Exception {
        buttonBrowse =
            (JButton) Beans.instantiate(getClass().getClassLoader(),
                                        JButton.class.getName());
        textFile = (JTextField) Beans.instantiate(getClass().getClassLoader(),
                                                  JTextField.class.getName());
        border = BorderFactory.createTitledBorder("XMLC Options");
        textCommandLine =
            (JTextField) Beans.instantiate(getClass().getClassLoader(),
                                           JTextField.class.getName());
        labelCommandLine =
            (JLabel) Beans.instantiate(getClass().getClassLoader(),
                                       JLabel.class.getName());
        labelFile = (JLabel) Beans.instantiate(getClass().getClassLoader(),
                                               JLabel.class.getName());
        buttonClear = (JButton) Beans.instantiate(getClass().getClassLoader(),
                                                  JButton.class.getName());
        buttonTool = (JButton) Beans.instantiate(getClass().getClassLoader(), JButton.class.getName());
        textFile.setMinimumSize(new Dimension(100, 21));
        textFile.setPreferredSize(new Dimension(100, 21));
        textFile.setEditable(false);
        buttonBrowse.setText("Set...");
        textCommandLine.setText("jTextField1");
        labelCommandLine.setText("Command line parameters:");
        labelFile.setText("Option file:");
        buttonClear.setText("Clear");
        this.setLayout(layoutMain);
        this.setBorder(border);
        buttonTool.setText("...");
        this.add(textFile, new GridBagConstraints(0, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(1, 2, 2, 2), 100, 0));
        this.add(buttonBrowse, new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1, 2, 2, 2), 0, 0));
        this.add(labelCommandLine, new GridBagConstraints(0, 1, 4, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 2, 1, 2), 0, 0));
        this.add(textCommandLine, new GridBagConstraints(0, 2, 3, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(1, 2, 2, 2), 0, 0));
        this.add(labelFile, new GridBagConstraints(0, 3, 4, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 2, 1, 2), 0, 0));
        this.add(buttonClear, new GridBagConstraints(2, 4, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1, 2, 2, 2), 0, 0));
        this.add(buttonTool, new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1, 2, 2, 2), 0, 0));
    }

    /**
     * Method declaration
     *
     *
     * @param e
     *
     * @see
     */
    public void setEnabled(boolean b) {
        super.setEnabled(b);
        textCommandLine.setEnabled(b);
        textFile.setEnabled(b);
        buttonTool.setEnabled(b);
        buttonBrowse.setEnabled(b);
        buttonClear.setEnabled(b);
        textCommandLine.setBackground(UIManager.getColor(b ? "TextField.background"
                                                  : "Label.background"));
        textFile.setBackground(UIManager.getColor(b ? "TextField.background"
                                                  : "Label.background"));

    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    public OtterNode getNode() {
        return node;
    }

    /**
     * Method declaration
     *
     *
     * @param n
     *
     * @see
     */
    public void setNode(OtterNode n) {
        node = n;
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    public void readProperties() {
        String filename = null;
        String parameters = null;

        if (node == null) {
            buttonBrowse.setEnabled(false);
        } else {
            buttonBrowse.setEnabled(true);
            filename = node.getXMLCOptionFilename();
            parameters = node.getXMLCParameters();
        }
        if (filename != null) {
            File file = new File(filename);
            if (file.isFile()) {
              textFile.setText(filename);
            }
        }
        if (parameters != null) {
            textCommandLine.setText(parameters);
        }
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    public void writeProperties() {
        String parameters = textCommandLine.getText().trim();

        if (node != null) {
          node.setXMLCParameters(parameters);
          node.setXMLCOptionFilename(getValidFilename());
        }
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    private String getValidFilename() {
        String filename = textFile.getText().trim();

        if (!filename.toLowerCase().endsWith(".xmlc")) {
            filename = new String();
        } else {
            File f = new File(filename);

            if (!f.exists()) {
                filename = new String();
            }
        }
        if (filename.trim().length() == 0) {
            textFile.setText(new String());
        }
        return filename;
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    private boolean isValidFilename() {
        return (getValidFilename().length() > 0);
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    private void browseForFile() {
        JFileChooser    chooser;
        ExtensionFilter filter;
        File            file;
        String          fileDir = new String();
        String          fileName = new String();

        filter = new ExtensionFilter();
        filter.addExtension("xmlc");
        filter.setDescriptionTitle("XMLC option file");
        chooser = new JFileChooser();
        if (textFile.getText().trim().length() > 0) {
            chooser.setCurrentDirectory(new File(textFile.getText()));
        } else {
            String path = null;
            File nodeFile = null;
            path = node.getFilePath();
            if (path == null || path.trim().length() == 0) {
              path = node.getProject().getFilePath();
            }
            nodeFile = new File(path);
            chooser.setCurrentDirectory(new File(nodeFile.getParent()));
        }
        chooser.setFileFilter(filter);
        chooser.setDialogTitle("Select a XMLC option file");
        chooser.setApproveButtonText("OK");
        int v = chooser.showOpenDialog(this);

        this.requestFocus();
        buttonBrowse.requestFocus();
        if (v == JFileChooser.APPROVE_OPTION) {
            if (chooser.getSelectedFile() == null
                    || (!chooser.getSelectedFile().isFile())) {
                textFile.setText(new String());
            } else {
                fileDir = chooser.getCurrentDirectory().toString();
                fileDir = stripSlash(fileDir);
                fileName = chooser.getSelectedFile().getName();
                textFile.setText(fileDir + File.separator + fileName);
            }
        }
        chooser.removeAll();
        chooser = null;
    }

    /**
     * Method declaration
     *
     *
     * @param dir
     *
     * @return
     *
     * @see
     */
    private String stripSlash(String dir) {
        String stripped = new String(dir);

        if (dir != null) {
            if (dir.length() > 0) {
                if (dir.endsWith(File.separator)) {
                    stripped = dir.substring(0, dir.length() - 1);
                }
            }
        }
        return stripped;
    }

    /**
     * Class declaration
     *
     *
     * @author Paul Mahar
     * @version $Revision: 1.4 $
     */
    private class LocalButtonListener implements ActionListener {

        /**
         * Method declaration
         *
         *
         * @param e
         *
         * @see
         */
        public void actionPerformed(ActionEvent e) {
            Object source = e.getSource();

            if (source == buttonBrowse) {
                browseForFile();
            } else if (source == buttonClear) {
                textFile.setText(new String());
            }
        }

    }
}
