/*
 * Enhydra Java Application Server
 * The Initial Developer of the Original Code is Lutris Technologies Inc.
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc.
 * All Rights Reserved.
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License.
 *
 * $Id: XMLCProjectPropertyPage.java,v 1.1 2000/05/12 06:00:57 pmahar Exp $
 */
package org.enhydra.kelp.jbuilder.properties;

import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.jbuilder.node.PrimeProject;
import org.enhydra.kelp.common.wizard.xmlc.XMLCPropertyPanel;
import org.enhydra.kelp.common.swing.SwingUtil;
import com.borland.primetime.properties.*;
import com.borland.primetime.help.HelpTopic;
import com.borland.jbuilder.node.*;
import com.borland.primetime.help.ZipHelpTopic;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.Beans;

public class XMLCProjectPropertyPage extends PropertyPage {
  private final String HELP_PAGE = "file:../kelp1.2/doc/developer/jb-kelp.html#xmlcproject";
  private OtterProject otterProject;
  private XMLCPropertyPanel  propertyPanel;
  private BorderLayout layoutMain;

  public XMLCProjectPropertyPage(Object topic) {
    if (topic instanceof JBProject) {
      PrimeProject primeProject = null;
      otterProject = new PrimeProject((JBProject)topic);
      try {
        jbInit();
        pmInit();
      }
      catch(Exception e) {
        e.printStackTrace();
      }
    }
  }

  public void readProperties() {
    propertyPanel.readProperties();
    enableUI(true);
  }

  public HelpTopic getHelpTopic() {
    ZipHelpTopic t = new ZipHelpTopic( null, HELP_PAGE);
    return t;
  }

  public void writeProperties() {
    propertyPanel.writeProperties();
  }

  public XMLCProjectPropertyPage() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void enableUI(boolean enabled) {
  }

  private void jbInit() throws Exception {
    layoutMain =
	    (BorderLayout) Beans.instantiate(getClass().getClassLoader(),
		      BorderLayout.class.getName());
    propertyPanel =
	    (XMLCPropertyPanel) Beans.instantiate(getClass().getClassLoader(),
		      XMLCPropertyPanel.class.getName());

    propertyPanel.setPreferredSize(new Dimension(0,0));
    this.setLayout(layoutMain);
    this.add(propertyPanel, BorderLayout.CENTER);
  }

  private void pmInit() {
    propertyPanel.setProject(otterProject);
  }

}