/*
 * Enhydra Java Application Server
 * The Initial Developer of the Original Code is Lutris Technologies Inc.
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc.
 * All Rights Reserved.
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License.
 *
 * $Id: WebAppWizard.java,v 1.3 2000/08/01 07:09:13 pmahar Exp $
 */
package org.enhydra.kelp.jbuilder.wizard.webapp;

// Kelp imports
import org.enhydra.kelp.jbuilder.wizard.AbstractCodeGenWizard;
import org.enhydra.kelp.common.wizard.codegen.WebAppUtil;
import org.enhydra.kelp.common.wizard.codegen.CodeGenException;
import org.enhydra.kelp.common.swing.SwingUtil;
import org.enhydra.kelp.common.swing.IconSet;
import org.enhydra.kelp.KelpVersion;
import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.common.node.OtterNodeFactory;
import org.enhydra.kelp.jbuilder.node.PrimeProject;
import org.enhydra.kelp.jbuilder.node.PrimeProject;
import org.enhydra.kelp.common.node.OtterFolderNode;

// JBuilder Foundation imports
import com.borland.jbuilder.node.JBProject;
import com.borland.primetime.wizard.Wizard;
import com.borland.primetime.wizard.WizardAction;
import com.borland.primetime.wizard.WizardHost;
import com.borland.primetime.wizard.WizardManager;
import com.borland.primetime.wizard.WizardPage;

// Standard imports
import javax.swing.JOptionPane;

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%p
 */
public class WebAppWizard extends AbstractCodeGenWizard {
    private final String       HELP_TOPIC =
        "file:../kelp1.2/doc/developer/jb-kelp.html#appwizard";
    public static WizardAction WIZARD_EnhydraAppWizard =
        new WizardAction(WebAppUtil.getDisplayName(), 'X',
                         "Creates a new " + WebAppUtil.getDisplayName(),
                         IconSet.getSmallIcon(), IconSet.getLargeIcon(),
                         true, "Enhydra") {

        /**
         * Method declaration
         *
         *
         * @return
         *
         * @see
         */
        protected Wizard createWizard() {
            WebAppWizard wizard = new WebAppWizard();

            return wizard;
        }

        /**
         * Method declaration
         *
         *
         * @param source
         *
         * @see
         */
        public void update(Object source) {
            setEnabled(true);
        }

    };

    /**
     * Method declaration
     *
     *
     * @param majorVersion
     * @param minorVersion
     *
     * @see
     */
    public static void initOpenTool(byte majorVersion, byte minorVersion) {
        WizardManager.registerWizardAction(WIZARD_EnhydraAppWizard);
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    public String getDisplayName() {
        return WebAppUtil.getDisplayName();
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    public String getHelpTopic() {
        return HELP_TOPIC;
    }

    /**
     * Method declaration
     *
     *
     * @param host
     *
     * @return
     *
     * @see
     */
    public WizardPage invokeWizard(WizardHost host) {
         WizardPage page = null;
        OtterProject otterProject = null;
        WebAppUtil   util = null;
        otterProject = initProject(host);
        if (otterProject != null) {
          try {
            if (! WebAppUtil.isCodeGenAvailable()) {
              throw new CodeGenException("Enhydra Code Generator classes not found in IDE class path");
            }
            util = new WebAppUtil(otterProject);
            page = invokeWizard(host, util);
          } catch (CodeGenException e) {
            JOptionPane.showMessageDialog(
               host.getDialogParent(),
               e.getMessage(),
               WebAppUtil.getDisplayName() + " Wizard",
               JOptionPane.ERROR_MESSAGE);
          }
        }
        return page;
    }

    /**
     *
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    public String[] getSteps() {
        String[] steps = new String[4];

        steps[0] =
            "Use the XMLC Compiler Wizard to compile your html pages into DOM classes.<BR>";
        steps[1] = "Make the project to compile the java files.";
        steps[2] = "Start the MultiServer by running the project.";
        steps[3] = "From your browser enter: http:\\localhost:9000";
        return steps;
    }

}
